--- modules/linux/Makefile.orig
+++ modules/linux/Makefile
@@ -1,17 +1,22 @@
 # $FreeBSD: src/sys/modules/linux/Makefile,v 1.67 2006/05/05 16:10:45 ambrisko Exp $
 
-.PATH: ${.CURDIR}/../../compat/linux ${.CURDIR}/../../${MACHINE_ARCH}/linux
+.if ${MACHINE_ARCH} == "amd64"
+SFX= 32
+CFLAGS+=-DCOMPAT_IA32 -DCOMPAT_LINUX32
+.endif
+
+.PATH: ${.CURDIR}/../../compat/linux ${.CURDIR}/../../${MACHINE_ARCH}/linux${SFX}
 
 KMOD=	linux
-SRCS=	linux_dummy.c linux_file.c linux_getcwd.c linux_ioctl.c linux_ipc.c \
-	linux_machdep.c linux_mib.c linux_misc.c linux_signal.c linux_socket.c \
-	linux_stats.c linux_sysctl.c linux_sysent.c linux_sysvec.c \
-	linux_util.c opt_inet6.h opt_mac.h \
+SRCS=	linux${SFX}_dummy.c linux_emul.c linux_file.c linux_futex.c linux_getcwd.c linux_ioctl.c \
+	linux_ipc.c linux${SFX}_machdep.c linux_mib.c linux_misc.c linux_signal.c \
+	linux_socket.c linux_stats.c linux_sysctl.c linux${SFX}_sysent.c linux${SFX}_sysvec.c \
+	linux_uid16.c linux_util.c linux_time.c opt_inet6.h opt_mac.h opt_compat.h opt_posix.h \
 	vnode_if.h device_if.h bus_if.h
-OBJS=	linux_locore.o
+OBJS=	linux${SFX}_locore.o
 
 .if ${MACHINE_ARCH} == "i386"
-SRCS+=	linux_ptrace.c linux_uid16.c imgact_linux.c opt_cpu.h
+SRCS+=	linux_ptrace.c imgact_linux.c opt_cpu.h
 .endif
 
 EXPORT_SYMS=
@@ -22,19 +27,19 @@
 EXPORT_SYMS+=	linux_ioctl_register_handler
 EXPORT_SYMS+=	linux_ioctl_unregister_handler
 
-CLEANFILES=	linux_assym.h linux_genassym.o
+CLEANFILES=	linux${SFX}_assym.h linux${SFX}_genassym.o
 
-linux_assym.h: linux_genassym.o
+linux${SFX}_assym.h: linux${SFX}_genassym.o
 .if exists(@)
-linux_assym.h: @/kern/genassym.sh
+linux${SFX}_assym.h: @/kern/genassym.sh
 .endif
-	sh @/kern/genassym.sh linux_genassym.o > ${.TARGET}
+	sh @/kern/genassym.sh linux${SFX}_genassym.o > ${.TARGET}
 
-linux_locore.o: linux_locore.s linux_assym.h
+linux${SFX}_locore.o: linux${SFX}_locore.s linux${SFX}_assym.h
 	${CC} -c -x assembler-with-cpp -DLOCORE ${CFLAGS} \
 	    ${.IMPSRC} -o ${.TARGET}
 
-linux_genassym.o: linux_genassym.c linux.h @ machine
+linux${SFX}_genassym.o: linux${SFX}_genassym.c linux.h @ machine
 	${CC} -c ${CFLAGS:N-fno-common} ${.IMPSRC}
 
 .if !defined(KERNBUILDDIR)
--- sys/eventhandler.h.orig
+++ sys/eventhandler.h
@@ -162,10 +162,11 @@
  * exec handlers are called with Giant, but that is by accident.
  */
 struct proc;
+struct image_params;
 
 typedef void (*exitlist_fn)(void *, struct proc *);
 typedef void (*forklist_fn)(void *, struct proc *, struct proc *, int);
-typedef void (*execlist_fn)(void *, struct proc *);
+typedef void (*execlist_fn)(void *, struct proc *, struct image_params *);
 
 EVENTHANDLER_DECLARE(process_exit, exitlist_fn);
 EVENTHANDLER_DECLARE(process_fork, forklist_fn);
@@ -174,4 +175,7 @@
 typedef void (*uma_zone_chfn)(void *);
 EVENTHANDLER_DECLARE(nmbclusters_change, uma_zone_chfn);
 EVENTHANDLER_DECLARE(maxsockets_change, uma_zone_chfn);
+
+typedef void(*schedtail_fn)(void *, struct proc *);
+EVENTHANDLER_DECLARE(schedtail, schedtail_fn);
 #endif /* SYS_EVENTHANDLER_H */
--- sys/imgact.h.orig
+++ sys/imgact.h
@@ -63,6 +63,7 @@
 	unsigned long ps_strings; /* PS_STRINGS for BSD/OS binaries */
 	size_t auxarg_size;
 	struct image_args *args;	/* system call arguments */
+	struct sysentvec *sysent;	/* system entry vector */
 };
 
 #ifdef _KERNEL
